# Class X509ExtendedKeyManager

java.lang.Object
javax.net.ssl.X509ExtendedKeyManager

All Implemented Interfaces:
  `KeyManager, X509KeyManager`

public abstract class X509ExtendedKeyManager extends Object implements X509KeyManager
Abstract class that provides for extension of the X509KeyManager interface.

Methods in this class should be overridden to provide actual implementations.

Since:
  1.5

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`X509ExtendedKeyManager()`
Constructor used by subclasses only.

## Method Summary

Modifier and Type
Method
Description
`String`
`chooseEngineClientAlias(String[] keyType, Principal[] issuers, SSLEngine engine)`
Choose an alias to authenticate the client side of an `SSLEngine` connection given the public key type and the list of certificate issuer authorities recognized by the peer (if any).
`String`
`chooseEngineServerAlias(String keyType, Principal[] issuers, SSLEngine engine)`
Choose an alias to authenticate the server side of an `SSLEngine` connection given the public key type and the list of certificate issuer authorities recognized by the peer (if any).

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

### Methods declared in interface X509KeyManager

`chooseClientAlias, chooseServerAlias, getCertificateChain, getClientAliases, getPrivateKey, getServerAliases`
Modifier and Type
Method
Description
`String`
`chooseClientAlias(String[] keyType, Principal[] issuers, Socket socket)`
Choose an alias to authenticate the client side of a secure socket given the public key type and the list of certificate issuer authorities recognized by the peer (if any).
`String`
`chooseServerAlias(String keyType, Principal[] issuers, Socket socket)`
Choose an alias to authenticate the server side of a secure socket given the public key type and the list of certificate issuer authorities recognized by the peer (if any).
`X509Certificate[]`
`getCertificateChain(String alias)`
Returns the certificate chain associated with the given alias.
`String[]`
`getClientAliases(String keyType, Principal[] issuers)`
Get the matching aliases for authenticating the client side of a secure socket given the public key type and the list of certificate issuer authorities recognized by the peer (if any).
`PrivateKey`
`getPrivateKey(String alias)`
Returns the key associated with the given alias.
`String[]`
`getServerAliases(String keyType, Principal[] issuers)`
Get the matching aliases for authenticating the server side of a secure socket given the public key type and the list of certificate issuer authorities recognized by the peer (if any).

## Constructor Details

### X509ExtendedKeyManager

protected X509ExtendedKeyManager()
Constructor used by subclasses only.

## Method Details

### chooseEngineClientAlias

public String chooseEngineClientAlias(String[] keyType, Principal[] issuers, SSLEngine engine)
Choose an alias to authenticate the client side of an `SSLEngine` connection given the public key type and the list of certificate issuer authorities recognized by the peer (if any).

The default implementation returns null.

Parameters:
  `keyType` - the key algorithm type name(s), ordered with the most-preferred key type first.
  `issuers` - the list of acceptable CA issuer subject names or null if it does not matter which issuers are used.
  `engine` - the `SSLEngine` to be used for this connection. This parameter can be null, which indicates that implementations of this interface are free to select an alias applicable to any engine.
Returns:
  the alias name for the desired key, or null if there are no matches.

### chooseEngineServerAlias

public String chooseEngineServerAlias(String keyType, Principal[] issuers, SSLEngine engine)
Choose an alias to authenticate the server side of an `SSLEngine` connection given the public key type and the list of certificate issuer authorities recognized by the peer (if any).

The default implementation returns null.

Parameters:
  `keyType` - the key algorithm type name.
  `issuers` - the list of acceptable CA issuer subject names or null if it does not matter which issuers are used.
  `engine` - the `SSLEngine` to be used for this connection. This parameter can be null, which indicates that implementations of this interface are free to select an alias applicable to any engine.
Returns:
  the alias name for the desired key, or null if there are no matches.